=== debian/changelog ===
openal-soft (1:1.15.1-5) unstable; urgency=medium

  * Team upload
  * openal-info and makehrtf must have Breaks and Replaces on
    libopenal-dev-bin (Policy §7.3, 7.4)

 -- Simon McVittie <smcv@debian.org>  Sun, 17 Aug 2014 13:38:50 +0100

openal-soft (1:1.15.1-4) unstable; urgency=medium

  * Added etcconf.patch to bring back the default conf file, 
    closes: 755862, 756891
  * Added debug packages. (Closes: 659364)
  * Made the additional binaries into separate packages.

 -- Bret Curtis <psi29a@gmail.com>  Mon, 4 Aug 2014 08:38:25 +0100

openal-soft (1:1.15.1-3) unstable; urgency=medium

  * Removing RoarAudio (libsndio) dependency until bug:755846 is fixed.
  * The above also happens to fix the multi-arch problem. (Closes: 756066)

 -- Bret Curtis <psi29a@gmail.com>  Fri, 25 Jul 2014 08:37:25 +0100

openal-soft (1:1.15.1-2) unstable; urgency=medium

  * Updated debian/copyright. (Closes: 755793)

 -- Bret Curtis <psi29a@gmail.com>  Wed, 23 Jul 2014 08:36:25 +0100

openal-soft (1:1.15.1-1) unstable; urgency=medium

  * Added openal-info binary. (Closes: 659198)
  * Added makehrtf binary.
  * Added 'audio' to short description. (Closes: 598064) 
  * Added FLAGS fixes for cmake in rules for hardening.
  * Added man pages for the two binaries.
  * New upstream release. (Closes: 731159)
  * Removed libsndio-dlopen-change.patch, no longer required.
  * Removed no-fpuextended.patch, macros no longer used.
  * Removed need for lintian overrides.

 -- Bret Curtis <psi29a@gmail.com>  Wed, 16 Jul 2014 08:35:25 +0100

openal-soft (1:1.14-5) unstable; urgency=medium

  [Cyril Brulebois]
  * Remove myself from Uploaders.

  [Bret Curtis]
  * Added myself to uploaders.
  * Updated Standards-Version to 3.9.5
  * Removed DM-Upload-Allowed as it is obsolete.
  * Added symbols file for libopenal1 (Closes: 662839)
  * Removed Andres Mejia from uploaders (Closes: 743575)

 -- Bret Curtis <psi29a@gmail.com>  Tue, 01 Jul 2014 08:35:25 +0100
