=== debian/changelog ===
openal-soft (1:1.16.0~25-1~sid+1) unstable; urgency=low

  * Nightly build.

 -- Simon McVittie <smcv@debian.org>  Wed, 27 May 2015 23:22:05 -0400

openal-soft (1:1.16.0-1) experimental; urgency=medium

  * Team upload

  [ Bret Curtis ]
  * New upstream release.
  * Updated descriptions of packages.
  * Updated libopenal1.symbols
  * Removed etconf.patch, we now install alsoft.conf via debian/rules.
  * Added HRTF datasets, so it all "just works".
  * Updated copyright file
  * Updated standards

  [ Simon McVittie ]
  * debian/copyright: add more copyright holders and licenses

 -- Simon McVittie <smcv@debian.org>  Sun, 08 Feb 2015 23:04:56 +0000
