=== debian/rules ===
--- 
+++ 
@@ -15,13 +15,9 @@
 # For multiarch
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-CFLAGS = -Wall $(shell dpkg-buildflags --get CPPFLAGS 2>/dev/null) $(shell dpkg-buildflags --get CFLAGS 2>/dev/null | sed -e 's/-g\|-O2//g')
-
 # Use this variable to allow options passed to cmake to be overridable
 DEB_CMAKE_OPTIONS ?= -DCMAKE_VERBOSE_MAKEFILE=ON \
-		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		-DCMAKE_INSTALL_PREFIX="/usr" \
-		-DCMAKE_C_FLAGS="$(CFLAGS)" \
 		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
 		-DEXAMPLES=OFF \
 		..
@@ -49,15 +45,23 @@
 	cd $(BUILD_TREE) && \
 		cmake $(DEB_CMAKE_OPTIONS)
 
+override_dh_installchangelogs:
+#	dh_installchangelogs ChangeLog 
+
 override_dh_strip:
 	dh_strip -plibopenal1 --dbg-package=libopenal1-dbg
 	dh_strip
+
+copyright_check:
+	${MAKE} -f /usr/share/cdbs/1/rules/utils.mk debian/stamp-copyright-check
+	rm debian/stamp-copyright-check
 
 override_dh_auto_build:
 	$(MAKE) --directory=$(BUILD_TREE)
 
 override_dh_auto_install:
 	$(MAKE) --directory=$(BUILD_TREE) install DESTDIR=$(CURDIR)/debian/tmp
+	install -d debian/tmp/etc/openal
 
 override_dh_shlibdeps: debian/tmp/openal-soft-Recommends-dummy.so debian/tmp/openal-soft-Suggests-dummy.so
 	dh_shlibdeps -O--parallel
@@ -72,6 +76,3 @@
 debian/tmp/openal-soft-Suggests-dummy.so:
 	mkdir -p debian/tmp
 	cc -xc -shared -Wl,--no-as-needed -o $@ /dev/null $(DLOPENED_SUGGESTS_LIBS)
-
-get-orig-source:
-	$(dir $_)openal-soft-get-orig-source
